#include <stdio.h>
#include <stdlib.h>

#include "list.h"
#include "queue.h"

void print_queue (integer_queue_t *queue) {

  integer_list_elmt_t* elem = integer_list_head (queue);
  for (; elem != integer_list_tail (queue);
       elem = integer_list_next (elem)) {
    printf ("%d, ", integer_list_data (elem));
  }

  elem = integer_list_tail (queue);

  if (elem != NULL) {
    printf ("%d", integer_list_data (elem));
  }
  printf ("\n");
}

int sum_queue_elements (integer_queue_t *queue) {

  int sum = 0;

  /* TODO */

  return sum;
}

int main (int argc, char** argv){

  if (argc < 2) {
    printf ("Usage %s string\n", argv[0]);
    return EXIT_SUCCESS;
  }

  integer_queue_t queue;
  integer_queue_init (&queue);
  for (int i = 1; i < argc; i++) {
    integer_queue_enqueue (&queue, atoi(argv[i]));
  }

  printf ("Queue before: ");
  print_queue (&queue);

  int result = sum_queue_elements (&queue);

  printf ("The sum of elements of the queue is \"%d\"\n", result);

  printf ("Queue after: ");
  print_queue (&queue);

  integer_queue_destroy (&queue);

  return EXIT_SUCCESS;
}
