#include <stdlib.h>
#include <stdio.h>

#include "interval.h"

int main (int argc, char** argv) {

  interval_t x;
  x.lb = 1.0;
  x.ub = 2.0;

  interval_t y;
  y.lb = -2.0;
  y.ub = -1.0;

  printf ("x = %s\n", interval2string (x));
  printf ("y = %s\n", interval2string (y));

  printf ("add(x, y) = %s\n", interval2string (add(x,y)));
  printf ("sub(x, y) = %s\n", interval2string (sub(x,y)));
  printf ("mul(x, y) = %s\n", interval2string (mul(x,y)));

  return EXIT_SUCCESS;
}
